using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.IO;
using System.Reflection;
using NLog;
using Raytheon.Common;

namespace Raytheon.Instruments
{
   [ExportInstrumentFactory(ModelNumber = "CommDeviceUdpFactory")]
   public class CommDeviceUdpFactory : IInstrumentFactory
   {
      private readonly List<Type> _supportedInterfaces = new List<Type>();

      private readonly IConfigurationManager _configurationManager;
      private const string DefaultConfigPath = @"C:\ProgramData\Raytheon\InstrumentManagerService";
      private static string DefaultPath;

      public CommDeviceUdpFactory(string defaultConfigPath = DefaultConfigPath)
         : this(null, defaultConfigPath)
      {
      }

      /// <summary>
      /// CommDeviceUdpFactory injection constructor
      /// </summary>
      [ImportingConstructor]
      public CommDeviceUdpFactory([Import(AllowDefault = false)] IConfigurationManager configManager,
                           [Import(AllowDefault = true)] string defaultConfigPath = null)
      {
         DefaultPath = defaultConfigPath;

         if (LogManager.Configuration == null)
         {
            var assemblyFolder = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
            LogManager.Configuration = new NLog.Config.XmlLoggingConfiguration(assemblyFolder + "\\nlog.config");
         }

         _configurationManager = configManager ?? GetConfigurationManager();
         _supportedInterfaces.Add(typeof(ICommDevice));
      }
      /// <summary>
      /// Gets the instrument
      /// </summary>
      /// <param name="name"></param>
      /// <returns></returns>
      public IInstrument GetInstrument(string name)
      {
         try
         {
            return new CommDeviceUdp(name, _configurationManager);
         }
         catch (Exception)
         {
            throw;
         }
      }

      /// <summary>
      /// Gets the instrument
      /// </summary>
      /// <param name="name"></param>
      /// <returns></returns>
      public object GetInstrument(string name, bool simulateHw)
      {
         try
         {
            return new CommDeviceUdp(name, _configurationManager);
         }
         catch (Exception)
         {
            throw;
         }
      }

      /// <summary>
      /// Gets supported interfaces
      /// </summary>
      /// <returns></returns>
      public ICollection<Type> GetSupportedInterfaces()
      {
         return _supportedInterfaces.ToArray();
      }

      /// <summary>
      /// returns configuration based on the predefined path or default path c:/ProgramData/Raytheon/InstrumentManagerService
      /// </summary>
      /// <returns></returns>
      private static IConfigurationManager GetConfigurationManager()
      {
         return string.IsNullOrEmpty(DefaultPath) ? new RaytheonConfigurationManager() : new RaytheonConfigurationManager(DefaultPath);
      }
   }
}